#ifndef WAVE_H
#define WAVE_H

#include <reg51.h>
#include <intrins.h>
#include "config_stc.h"
#include "delay.h"

#ifndef uint8
#define uint8 unsigned char
#endif

#ifndef int8
#define int8 char
#endif

#ifndef uint16
#define uint16 unsigned int
#endif

#ifndef uint32
#define uint32 unsigned long int
#endif

#define FOSC 24000000UL                           //ʱ
#define SPWM_VECTOR 22                             //PWMж
#define TIMER_1 3                                 //ʱ1ж
#define CBIF 0x40                                 //PWMжϱ־
#define SIN_TABLE_PWM_HZ 150000                   //T_SinTableʹõPWMƵʣFOSC/SIN_TABLE_PWM_HZPWM
#define SIN_POINTS 1000                           //T_SinTable
#define SIN_OFFSET 1                              //SINֵƫһηת͵ڶηתΪ0Ӧ÷תΣֻתһΣɵƽ
#define WAVE_NUM 2                                //ѡʱֻ˷ҲΪ2Wave_Shape=0ʱתʾVCCѹ
#define PWM_MAX_DUTY 99                           //PWMռձ
#define PWM_MIN_DUTY 1                            //PWMСռձ
#define PWM_MIN_WIDTH 50                         //PWMСȳʱ ns
#define PWM_MAX_HZ 4000000                        //PWMƵ4MHz
#define PWM_MIN_HZ 1                              //PWMСƵ1Hz
#define SIN_MAX_HZ 10000                          //SINƵ10kHz
#define SIN_MIN_HZ 1                              //SINСƵ1Hz
#define CKS_50HZ 12                               //С50HzʱӷƵ
#define PWMC (*(uint16 volatile xdata *)0xfff0)   //PWM
#define PWMCKS (*(uint8 volatile xdata *)0xfff2)  //PWMʱѡλ
#define PWM3T1 (*(uint16 volatile xdata *)0xff10) //PWM3T1
#define PWM3T2 (*(uint16 volatile xdata *)0xff12) //PWM3T2
#define PWM3CR (*(uint8 volatile xdata *)0xff14)  //PWM3λ
#define PWM4T1 (*(uint16 volatile xdata *)0xFF20) //PWM4T1
#define PWM4T2 (*(uint16 volatile xdata *)0xFF22) //PWM4T2
#define PWM4CR (*(uint8 volatile xdata *)0xFF24)  //PWM4λ

extern uint8 PWMCKS_PS;       //ϵͳʱӷƵϵ
extern uint32 PWM_Hz;         //PWMƵ
extern uint32 PWM_Hz_Pre;     //¼һPWMƵ
extern int8 PWM_Duty;         //PWMռձ
extern uint32 SIN_Hz;         //SINƵ
extern uint8 Wave_Shape;      //α־ 1: 2:Ҳ
extern uint8 Wave_Shape_Pre;  //ϴβα־
extern uint8 Sin_Table_Times; //SIN
extern bit WAVE_ON;           //α־λ 1:ON 2:OFF

void Set_Wave_Shape();
void Wave_OFF();
void Set_PWMCKS_PS();
void Set_PWM_Cycle();
void Set_PWM_Width();
void Set_Sin_Table_Times();
#endif